blob: 5514c23f45c24fdbe0968c95275103ef2e545f09 [file] [log] [blame]
Josh Poimboeuf67326662016-09-19 10:52:14 -05001#!/bin/bash
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Josh Poimboeuf67326662016-09-19 10:52:14 -05003#
4# Translate stack dump function offsets.
5#
6# addr2line doesn't work with KASLR addresses. This works similarly to
7# addr2line, but instead takes the 'func+0x123' format as input:
8#
9# $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
10# meminfo_proc_show+0x5/0x568:
11# meminfo_proc_show at fs/proc/meminfo.c:27
12#
13# If the address is part of an inlined function, the full inline call chain is
14# printed:
15#
16# $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
17# native_write_msr+0x6/0x27:
18# arch_static_branch at arch/x86/include/asm/msr.h:121
19# (inlined by) static_key_false at include/linux/jump_label.h:125
20# (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
21#
22# The function size after the '/' in the input is optional, but recommended.
23# It's used to help disambiguate any duplicate symbol names, which can occur
24# rarely. If the size is omitted for a duplicate symbol then it's possible for
25# multiple code sites to be printed:
26#
27# $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
28# raw_ioctl+0x5/0x20:
29# raw_ioctl at drivers/char/raw.c:122
30#
31# raw_ioctl+0x5/0xb1:
32# raw_ioctl at net/ipv4/raw.c:876
33#
34# Multiple addresses can be specified on a single command line:
35#
36# $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
37# type_show+0x10/0x2d:
38# type_show at drivers/video/backlight/backlight.c:213
39#
40# free_reserved_area+0x90/0x123:
41# free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
42
43
44set -o errexit
45set -o nounset
46
Josh Poimboeuf67326662016-09-19 10:52:14 -050047usage() {
Peter Zijlstra (Intel)689135f2018-06-04 13:48:31 -050048 echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
Josh Poimboeuf67326662016-09-19 10:52:14 -050049 exit 1
50}
51
52warn() {
53 echo "$1" >&2
54}
55
56die() {
57 echo "ERROR: $1" >&2
58 exit 1
59}
60
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -070061READELF="${CROSS_COMPILE:-}readelf"
62ADDR2LINE="${CROSS_COMPILE:-}addr2line"
63AWK="awk"
Josh Poimboeufa41a2e22022-07-21 11:01:24 -070064GREP="grep"
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -070065
66command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed"
67command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed"
68command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed"
69
Josh Poimboeuf67326662016-09-19 10:52:14 -050070# Try to figure out the source directory prefix so we can remove it from the
71# addr2line output. HACK ALERT: This assumes that start_kernel() is in
Randy Dunlapf5f67cc2018-11-16 15:08:22 -080072# init/main.c! This only works for vmlinux. Otherwise it falls back to
Josh Poimboeuf67326662016-09-19 10:52:14 -050073# printing the absolute path.
74find_dir_prefix() {
75 local objfile=$1
76
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -070077 local start_kernel_addr=$(${READELF} --symbols --wide $objfile | ${AWK} '$8 == "start_kernel" {printf "0x%s", $2}')
Josh Poimboeuf67326662016-09-19 10:52:14 -050078 [[ -z $start_kernel_addr ]] && return
79
Liu, Changcheng95a87982017-11-29 16:10:25 -080080 local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
Josh Poimboeuf67326662016-09-19 10:52:14 -050081 [[ -z $file_line ]] && return
82
83 local prefix=${file_line%init/main.c:*}
84 if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
85 return
86 fi
87
88 DIR_PREFIX=$prefix
89 return 0
90}
91
92__faddr2line() {
93 local objfile=$1
94 local func_addr=$2
95 local dir_prefix=$3
96 local print_warnings=$4
97
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -070098 local sym_name=${func_addr%+*}
Josh Poimboeufdcea9972022-06-01 17:42:22 -070099 local func_offset=${func_addr#*+}
100 func_offset=${func_offset%/*}
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700101 local user_size=
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700102 local file_type
103 local is_vmlinux=0
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700104 [[ $func_addr =~ "/" ]] && user_size=${func_addr#*/}
Josh Poimboeuf67326662016-09-19 10:52:14 -0500105
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700106 if [[ -z $sym_name ]] || [[ -z $func_offset ]] || [[ $sym_name = $func_addr ]]; then
Josh Poimboeuf67326662016-09-19 10:52:14 -0500107 warn "bad func+offset $func_addr"
108 DONE=1
109 return
110 fi
111
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700112 # vmlinux uses absolute addresses in the section table rather than
113 # section offsets.
114 local file_type=$(${READELF} --file-header $objfile |
115 ${AWK} '$1 == "Type:" { print $2; exit }')
Josh Poimboeufb6a50682022-07-21 11:01:23 -0700116 if [[ $file_type = "EXEC" ]] || [[ $file_type == "DYN" ]]; then
117 is_vmlinux=1
118 fi
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700119
Josh Poimboeuf67326662016-09-19 10:52:14 -0500120 # Go through each of the object's symbols which match the func name.
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700121 # In rare cases there might be duplicates, in which case we print all
122 # matches.
123 while read line; do
124 local fields=($line)
125 local sym_addr=0x${fields[1]}
126 local sym_elf_size=${fields[2]}
127 local sym_sec=${fields[6]}
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700128 local sec_size
129 local sec_name
Josh Poimboeufefdb4162016-10-25 09:51:11 -0500130
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700131 # Get the section size:
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700132 sec_size=$(${READELF} --section-headers --wide $objfile |
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700133 sed 's/\[ /\[/' |
134 ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }')
135
136 if [[ -z $sec_size ]]; then
137 warn "bad section size: section: $sym_sec"
Josh Poimboeufefdb4162016-10-25 09:51:11 -0500138 DONE=1
139 return
140 fi
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700141
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700142 # Get the section name:
143 sec_name=$(${READELF} --section-headers --wide $objfile |
144 sed 's/\[ /\[/' |
145 ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print $2; exit }')
146
147 if [[ -z $sec_name ]]; then
148 warn "bad section name: section: $sym_sec"
149 DONE=1
150 return
151 fi
152
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700153 # Calculate the symbol size.
154 #
155 # Unfortunately we can't use the ELF size, because kallsyms
156 # also includes the padding bytes in its size calculation. For
157 # kallsyms, the size calculation is the distance between the
158 # symbol and the next symbol in a sorted list.
159 local sym_size
160 local cur_sym_addr
161 local found=0
162 while read line; do
163 local fields=($line)
164 cur_sym_addr=0x${fields[1]}
165 local cur_sym_elf_size=${fields[2]}
166 local cur_sym_name=${fields[7]:-}
167
168 if [[ $cur_sym_addr = $sym_addr ]] &&
169 [[ $cur_sym_elf_size = $sym_elf_size ]] &&
170 [[ $cur_sym_name = $sym_name ]]; then
171 found=1
172 continue
173 fi
174
175 if [[ $found = 1 ]]; then
176 sym_size=$(($cur_sym_addr - $sym_addr))
177 [[ $sym_size -lt $sym_elf_size ]] && continue;
178 found=2
179 break
180 fi
181 done < <(${READELF} --symbols --wide $objfile | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2)
182
183 if [[ $found = 0 ]]; then
184 warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size"
185 DONE=1
186 return
187 fi
188
189 # If nothing was found after the symbol, assume it's the last
190 # symbol in the section.
191 [[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr))
192
193 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
194 warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr"
195 DONE=1
196 return
197 fi
198
Josh Poimboeufefdb4162016-10-25 09:51:11 -0500199 sym_size=0x$(printf %x $sym_size)
Josh Poimboeuf67326662016-09-19 10:52:14 -0500200
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700201 # Calculate the address from user-supplied offset:
202 local addr=$(($sym_addr + $func_offset))
Josh Poimboeuf67326662016-09-19 10:52:14 -0500203 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700204 warn "bad address: $sym_addr + $func_offset"
Josh Poimboeuf67326662016-09-19 10:52:14 -0500205 DONE=1
206 return
207 fi
Josh Poimboeufefdb4162016-10-25 09:51:11 -0500208 addr=0x$(printf %x $addr)
Josh Poimboeuf67326662016-09-19 10:52:14 -0500209
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700210 # If the user provided a size, make sure it matches the symbol's size:
211 if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then
Josh Poimboeuf67326662016-09-19 10:52:14 -0500212 [[ $print_warnings = 1 ]] &&
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700213 echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)"
Josh Poimboeuf67326662016-09-19 10:52:14 -0500214 continue;
215 fi
216
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700217 # Make sure the provided offset is within the symbol's range:
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700218 if [[ $func_offset -gt $sym_size ]]; then
Josh Poimboeuf67326662016-09-19 10:52:14 -0500219 [[ $print_warnings = 1 ]] &&
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700220 echo "skipping $sym_name address at $addr due to size mismatch ($func_offset > $sym_size)"
Josh Poimboeuf67326662016-09-19 10:52:14 -0500221 continue
222 fi
223
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700224 # In case of duplicates or multiple addresses specified on the
225 # cmdline, separate multiple entries with a blank line:
Josh Poimboeuf67326662016-09-19 10:52:14 -0500226 [[ $FIRST = 0 ]] && echo
227 FIRST=0
228
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700229 echo "$sym_name+$func_offset/$sym_size:"
Changbin Du6870c012018-04-05 16:18:29 -0700230
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700231 # Pass section address to addr2line and strip absolute paths
232 # from the output:
Josh Poimboeufdcea9972022-06-01 17:42:22 -0700233 local args="--functions --pretty-print --inlines --exe=$objfile"
234 [[ $is_vmlinux = 0 ]] && args="$args --section=$sec_name"
235 local output=$(${ADDR2LINE} $args $addr | sed "s; $dir_prefix\(\./\)*; ;")
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700236 [[ -z $output ]] && continue
237
238 # Default output (non --list):
Peter Zijlstra (Intel)689135f2018-06-04 13:48:31 -0500239 if [[ $LIST = 0 ]]; then
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700240 echo "$output" | while read -r line
Peter Zijlstra (Intel)689135f2018-06-04 13:48:31 -0500241 do
242 echo $line
243 done
244 DONE=1;
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700245 continue
Peter Zijlstra (Intel)689135f2018-06-04 13:48:31 -0500246 fi
247
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700248 # For --list, show each line with its corresponding source code:
249 echo "$output" | while read -r line
Changbin Du6870c012018-04-05 16:18:29 -0700250 do
Peter Zijlstra (Intel)689135f2018-06-04 13:48:31 -0500251 echo
Changbin Du6870c012018-04-05 16:18:29 -0700252 echo $line
Changbin Du78eb0c62018-05-11 16:02:11 -0700253 n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
254 n1=$[$n-5]
255 n2=$[$n+5]
256 f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700257 ${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
Changbin Du6870c012018-04-05 16:18:29 -0700258 done
259
Josh Poimboeuf67326662016-09-19 10:52:14 -0500260 DONE=1
261
Josh Poimboeuf1d1a0e72022-05-12 12:05:27 -0700262 done < <(${READELF} --symbols --wide $objfile | ${AWK} -v fn=$sym_name '$4 == "FUNC" && $8 == fn')
Josh Poimboeuf67326662016-09-19 10:52:14 -0500263}
264
265[[ $# -lt 2 ]] && usage
266
267objfile=$1
Peter Zijlstra (Intel)689135f2018-06-04 13:48:31 -0500268
269LIST=0
270[[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
271
Josh Poimboeuf67326662016-09-19 10:52:14 -0500272[[ ! -f $objfile ]] && die "can't find objfile $objfile"
273shift
274
Josh Poimboeufa41a2e22022-07-21 11:01:24 -0700275${READELF} --section-headers --wide $objfile | ${GREP} -q '\.debug_info' || die "CONFIG_DEBUG_INFO not enabled"
276
Josh Poimboeuf67326662016-09-19 10:52:14 -0500277DIR_PREFIX=supercalifragilisticexpialidocious
278find_dir_prefix $objfile
279
280FIRST=1
281while [[ $# -gt 0 ]]; do
282 func_addr=$1
283 shift
284
285 # print any matches found
286 DONE=0
287 __faddr2line $objfile $func_addr $DIR_PREFIX 0
288
289 # if no match was found, print warnings
290 if [[ $DONE = 0 ]]; then
291 __faddr2line $objfile $func_addr $DIR_PREFIX 1
292 warn "no match for $func_addr"
293 fi
294done